﻿local PassLoot = LibStub("AceAddon-3.0"):GetAddon("PassLoot");
local L = LibStub("AceLocale-3.0"):GetLocale("PassLoot_AtlasLoot");
local module = PassLoot:NewModule(L["ModuleName"], "AceEvent-3.0");

module.ConfigOptions_RuleDefaults = {
  -- { VariableName, Default },
  { "AtlasLootWishList", nil },
};
module.NewFilterValue = true;

function module:OnEnable()
  self:RegisterDefaultVariables(self.ConfigOptions_RuleDefaults);
  self:AddWidget(self.Widget);
  -- self:CheckDBVersion(1, "UpgradeDatabase");
end

function module:OnDisable()
  self:UnregisterDefaultVariables();
  self:RemoveWidgets();
end

function module:UpgradeDatabase(FromVersion, Rule)
  return;
end

function module:CreateWidget()
  local Frame = CreateFrame("Frame");
  Frame:SetWidth(150);
  Frame:SetHeight(30);
  
  Frame.Title = Frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal");
  Frame.Title:SetParent(Frame);
  Frame.Title:SetPoint("TOPLEFT", Frame, "TOPLEFT");
  Frame.Title:SetText(L["MatchWishList"]);
  
  Frame.Height = Frame:GetHeight();
  Frame.Width = Frame:GetWidth();

  Frame.Info = {
    L["FilterListName"],
    L["FilterListDesc"],
  };
  return Frame;
end
module.Widget = module:CreateWidget();

-- Local function to get the data and make sure it's valid data
function module.Widget:GetData(RuleNum)
  local Data = module:GetConfigOption("AtlasLootWishList", RuleNum);
  if ( Data ~= nil and Data ~= true ) then
    Data = true;
    module:SetConfigOption("AtlasLootWishList", Data);
  end
  return Data;
end

function module.Widget:GetNumFilters(RuleNum)
  local Value = self:GetData(RuleNum);
  if ( Value ) then
    return 1;
  else
    return 0;
  end
end

function module.Widget:AddNewFilter()
  module:SetConfigOption("AtlasLootWishList", module.NewFilterValue);
end

function module.Widget:RemoveFilter(Index)
  module:SetConfigOption("AtlasLootWishList", nil);
end

function module.Widget:DisplayWidget(Index)
end

function module.Widget:GetFilterText(Index)
  local Value = self:GetData();
  if ( Value ) then
    return L["MatchWishList"];
  end
end

function module.Widget:SetMatch(ItemLink, Tooltip)
  _, _, module.CurrentMatch = string.find(ItemLink, "|Hitem:(%d+):");
  module.CurrentMatch = tonumber(module.CurrentMatch);
  module:Debug("ItemID: "..(module.CurrentMatch or "nil"));
end

-- Returns true if an item is already in the wishlist
-- function AtlasLoot_WishListCheck(itemID, all)
function module.Widget:GetMatch(RuleNum, Index)
  local RuleValue = self:GetData(RuleNum);
  if ( RuleValue == true ) then
    return AtlasLoot_WishListCheck(module.CurrentMatch, true);
  end
  return true;
end
